//require base/Class.js

(function()
{

var callObjectFn = function(nameOrFn)
{
    //console.debug("nameOrFn = "+JSON.stringify(nameOrFn));

    var fn,type = typeof nameOrFn;
    if (type == "string")
    {
        fn = this[nameOrFn];
        if (!fn)
        {
            console.warn("'%s' is no method on %o", nameOrFn, this);
            return; 
        }
    }
    else 
    {
        fn = nameOrFn;
    }
    
    fn.apply(this,Array.prototype.slice.call(arguments,1));
    
};


var undefined;

this.PriorityQueue = Class.extend({
init:
    function()
    {
        this.objects = [];          // this.objects[<priority][<insertion-order] == obj
        this.objectsByName = {};    // this.objectsByName[name] == obj
    },
add:
    function(obj)
    {
        var priority,bucket,name,
        
        priority = obj.priority;
        name = obj.name;        
        bucket = this.objects[priority];
        
        if (!bucket)
        {
            bucket = [];
            this.objects[priority] = bucket;
        }
        bucket[bucket.length] = obj;
        
        if (name !== undefined)
        {
            this.objectsByName[name] = obj; 
        }
    },
/**
Call the method with the given name on all objects in the queue, adding all following arguments
*/    
call:
    function(nameOrFn)
    {        
        //console.debug("call nameOrFn = %o", nameOrFn);
        var i,t,array;
        for(i = this.objects.length - 1; i >= 0 ; i--)
        {
            var array = this.objects[i];
            //console.debug("array = "+JSON.stringify(array));
            if (array)
            {
                for (t = 0; t < array.length; t++)
                {
                    callObjectFn.apply(array[t],arguments);
                }
            }
        }                
    },    
callNamed:
    function(names, nameOrFn)
    {
        var queue = new PriorityQueue();
        for (var i = 0; i  < names.length; i++)
        {
            var obj = this.objectsByName[ names[ i ] ];
            if (obj)
            {
                queue.add(obj);
            }
            else
            {
                // XXX: Exception until OS-37 is fixed 
                if (names[i] != "RequiredBehaviour")
                {
                    console.warn("%s is not defined", names[i]);
                }
            }                
        }
        
        queue.call.apply(queue, Array.prototype.slice.call(arguments, 1));
    }
});

})();
ScriptLoader.signalLoaded("base/PriorityQueue.js");
